## ros-melodic-gazebo-video-monitor-plugins 0.5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
cmake_policy(SET CMP0048 NEW)
project(gazebo_video_monitor_plugins)

cmake_policy(SET CMP0054 NEW)

add_compile_options(-std=c++14)

find_package(catkin REQUIRED
  COMPONENTS
    message_generation
    gazebo_ros
    roscpp
    std_srvs
)

find_package(gazebo REQUIRED)

find_package(OpenCV REQUIRED)

################################################
## Declare ROS messages, services and actions ##
################################################

add_message_files(
  FILES
    Pose.msg
    Strings.msg
)

add_service_files(
  FILES
    SetCamera.srv
    StartGmcmRecording.srv
    StartGvmRecording.srv
    StopRecording.srv
)

generate_messages(
  DEPENDENCIES
)

###################################
## catkin specific configuration ##
###################################

list(APPEND VIDEO_PLUGINS
  gazebo_video_monitor_plugin
  gazebo_multi_video_monitor_plugin
  gazebo_multi_camera_monitor_plugin
  gazebo_multi_view_monitor_plugin
)

catkin_package(
  INCLUDE_DIRS
    include
  LIBRARIES
    gvm_multicamera_bootstrapper_plugin
    gazebo_video_recorder
    ${VIDEO_PLUGINS}
    camera_contains_plugin
  CATKIN_DEPENDS
    gazebo_ros
    message_runtime
    roscpp
    std_srvs
  DEPENDS
    OpenCV
)

###########
## Build ##
###########

include_directories(
  include
  ${catkin_INCLUDE_DIRS}
  ${GAZEBO_INCLUDE_DIRS}
  ${OpenCV_INCLUDE_DIRS}
)

link_directories(${GAZEBO_LIBRARY_DIRS})

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${GAZEBO_CXX_FLAGS}")

## Bootstrapper plugin ################
add_library(gvm_multicamera_bootstrapper_plugin
  src/sensors/gvm_multicamera_sensor.cpp
  src/gvm_multicamera_bootstrapper_plugin.cpp
)
add_dependencies(gvm_multicamera_bootstrapper_plugin
  ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS}
)
target_link_libraries(gvm_multicamera_bootstrapper_plugin
  ${catkin_LIBRARIES} ${GAZEBO_LIBRARIES}
)

## Video recorder #####################
add_library(gazebo_video_recorder
  src/utils/gazebo_video_recorder.cpp
)
target_link_libraries(gazebo_video_recorder
  ${catkin_LIBRARIES} ${GAZEBO_LIBRARIES} ${OpenCV_LIBRARIES}
)

## Video plugins ######################
foreach(PLUGIN ${VIDEO_PLUGINS})
  add_library(${PLUGIN}
    src/gazebo_monitor_base_plugin.cpp
    src/${PLUGIN}.cpp
  )
  add_dependencies(${PLUGIN}
    ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS}
  )
  target_link_libraries(${PLUGIN}
    ${catkin_LIBRARIES} ${GAZEBO_LIBRARIES} ${OpenCV_LIBRARIES}
    gazebo_video_recorder
  )
endforeach()

## Utility plugins ####################
add_library(camera_contains_plugin
  src/utils/box_marker_visualizer.cpp
  src/camera_contains_plugin.cpp
)
add_dependencies(camera_contains_plugin
  ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS}
)
target_link_libraries(camera_contains_plugin
  ${catkin_LIBRARIES} ${GAZEBO_LIBRARIES}
  yaml-cpp
)

#############
## Install ##
#############

install(
  TARGETS 
    gvm_multicamera_bootstrapper_plugin
    gazebo_video_recorder
    ${VIDEO_PLUGINS}
    camera_contains_plugin
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

# install(DIRECTORY test
#   DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
# )

=== debian/changelog ===
ros-melodic-gazebo-video-monitor-plugins (0.5.0-2stretch) stretch; urgency=high

  * Address gcc lambda bug
  * Fix logs
  * Fix pose multiplications for noetic
    Issue: https://osrf-migration.github.io/ignition-gh-pages/#!/ignitionrobotics/ign-math/pull-requests/301/page/1

 -- Nick Lamprianidis <nlamprian@gmail.com>  Sat, 26 Sep 2020 22:00:00 -0000

ros-melodic-gazebo-video-monitor-plugins (0.4.2-2stretch) stretch; urgency=high

  * Enable C++14

 -- Nick Lamprianidis <nlamprian@gmail.com>  Sat, 29 Aug 2020 22:00:00 -0000

ros-melodic-gazebo-video-monitor-plugins (0.4.1-2stretch) stretch; urgency=high

  * Fix cmake and compiler warnings

 -- Nick Lamprianidis <nlamprian@gmail.com>  Thu, 20 Aug 2020 22:00:00 -0000

ros-melodic-gazebo-video-monitor-plugins (0.4.0-2stretch) stretch; urgency=high

  * Add multi view monitor plugin
    Support quadrant camera streams in the video recorder
  * Add license notice

 -- Nick Lamprianidis <nlamprian@gmail.com>  Fri, 14 Aug 2020 22:00:00 -0000

ros-melodic-gazebo-video-monitor-plugins (0.3.0-2stretch) stretch; urgency=high

  * Various fixes
    * Fix bug with reading the cameraReference configurations
    * Fix success field on result when discarding in stop recording
    * Add a walking actor in video monitor plugin world as a dynamic element
    * Expose recorder library
  * Add multi video monitor plugin
  * Add multi camera monitor plugin
    * Add camera contains plugin and box marker visualizer
    * Add test world for multi camera monitor and camera contains plugins
    * Use default video name in the recorder when one is not provided
    * Fix gazebo topic names for camera images in multicamera sensor

 -- Nick Lamprianidis <nlamprian@gmail.com>  Wed, 12 Aug 2020 22:00:00 -0000

ros-melodic-gazebo-video-monitor-plugins (0.2.0-2stretch) stretch; urgency=high

  * Parameterize log prefixes
  * Drop specific OpenCV version
  * Refactor gazebo video monitor plugin
    * Introduce gazebo video recorder to host recording functionality and enable reusability
    * Introduce gazebo monitor base plugin to host common members and structure plugin initialization
    * Add option to disable the window in the gazebo video monitor plugin
    * Update documentation

 -- Nick Lamprianidis <nlamprian@gmail.com>  Sun, 28 Jun 2020 22:00:00 -0000

ros-melodic-gazebo-video-monitor-plugins (0.1.1-2stretch) stretch; urgency=high

  * Set path of temporary recording
  * Add fix for initial camera attachment

 -- Nick Lamprianidis <nlamprian@gmail.com>  Wed, 22 Apr 2020 22:00:00 -0000

ros-melodic-gazebo-video-monitor-plugins (0.1.0-2stretch) stretch; urgency=high

  * Add multicamera sensor and video monitor plugin

 -- Nick Lamprianidis <nlamprian@gmail.com>  Mon, 20 Apr 2020 22:00:00 -0000

=== debian/control ===
Source: ros-melodic-gazebo-video-monitor-plugins
Section: misc
Priority: optional
Maintainer: Nick Lamprianidis <nlamprian@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libopencv-dev, libyaml-cpp-dev, ros-melodic-catkin, ros-melodic-gazebo-ros, ros-melodic-message-generation, ros-melodic-roscpp, ros-melodic-std-srvs
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-gazebo-video-monitor-plugins
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libopencv-dev, ros-melodic-gazebo-ros, ros-melodic-message-runtime, ros-melodic-roscpp, ros-melodic-std-srvs
Description: The gazebo_video_monitor_plugins package

## ros-melodic-gazebo-video-monitor-plugins 0.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,15 +1,12 @@
-cmake_minimum_required(VERSION 2.8.3)
-cmake_policy(SET CMP0048 NEW)
+cmake_minimum_required(VERSION 3.1.0)
 project(gazebo_video_monitor_plugins)
-
-cmake_policy(SET CMP0054 NEW)
 
 add_compile_options(-std=c++14)
 
 find_package(catkin REQUIRED
   COMPONENTS
-    message_generation
     gazebo_ros
+    gazebo_video_monitor_msgs
     roscpp
     std_srvs
 )
@@ -17,28 +14,6 @@
 find_package(gazebo REQUIRED)
 
 find_package(OpenCV REQUIRED)
-
-################################################
-## Declare ROS messages, services and actions ##
-################################################
-
-add_message_files(
-  FILES
-    Pose.msg
-    Strings.msg
-)
-
-add_service_files(
-  FILES
-    SetCamera.srv
-    StartGmcmRecording.srv
-    StartGvmRecording.srv
-    StopRecording.srv
-)
-
-generate_messages(
-  DEPENDENCIES
-)
 
 ###################################
 ## catkin specific configuration ##
@@ -61,7 +36,7 @@
     camera_contains_plugin
   CATKIN_DEPENDS
     gazebo_ros
-    message_runtime
+    gazebo_video_monitor_msgs
     roscpp
     std_srvs
   DEPENDS
@@ -88,9 +63,6 @@
   src/sensors/gvm_multicamera_sensor.cpp
   src/gvm_multicamera_bootstrapper_plugin.cpp
 )
-add_dependencies(gvm_multicamera_bootstrapper_plugin
-  ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS}
-)
 target_link_libraries(gvm_multicamera_bootstrapper_plugin
   ${catkin_LIBRARIES} ${GAZEBO_LIBRARIES}
 )
@@ -109,9 +81,6 @@
     src/gazebo_monitor_base_plugin.cpp
     src/${PLUGIN}.cpp
   )
-  add_dependencies(${PLUGIN}
-    ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS}
-  )
   target_link_libraries(${PLUGIN}
     ${catkin_LIBRARIES} ${GAZEBO_LIBRARIES} ${OpenCV_LIBRARIES}
     gazebo_video_recorder
@@ -122,9 +91,6 @@
 add_library(camera_contains_plugin
   src/utils/box_marker_visualizer.cpp
   src/camera_contains_plugin.cpp
-)
-add_dependencies(camera_contains_plugin
-  ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS}
 )
 target_link_libraries(camera_contains_plugin
   ${catkin_LIBRARIES} ${GAZEBO_LIBRARIES}

=== debian/changelog ===
ros-melodic-gazebo-video-monitor-plugins (0.6.0-2bionic) bionic; urgency=high

  * Add metapackage
    * Move messages and services to gazebo_video_monitor_msgs
    * Update gazebo_video_monitor_plugins to use gazebo_video_monitor_msgs
    * Add gazebo_video_monitors metapackage

 -- Nick Lamprianidis <nlamprian@gmail.com>  Sat, 05 Dec 2020 23:00:00 -0000

ros-melodic-gazebo-video-monitor-plugins (0.5.0-2bionic) bionic; urgency=high

  * Address gcc lambda bug
  * Fix logs
  * Fix pose multiplications for noetic
    Issue: https://osrf-migration.github.io/ignition-gh-pages/#!/ignitionrobotics/ign-math/pull-requests/301/page/1

 -- Nick Lamprianidis <nlamprian@gmail.com>  Sat, 26 Sep 2020 22:00:00 -0000

ros-melodic-gazebo-video-monitor-plugins (0.4.2-2bionic) bionic; urgency=high

  * Enable C++14

 -- Nick Lamprianidis <nlamprian@gmail.com>  Sat, 29 Aug 2020 22:00:00 -0000

ros-melodic-gazebo-video-monitor-plugins (0.4.1-2bionic) bionic; urgency=high

  * Fix cmake and compiler warnings

 -- Nick Lamprianidis <nlamprian@gmail.com>  Thu, 20 Aug 2020 22:00:00 -0000

ros-melodic-gazebo-video-monitor-plugins (0.4.0-2bionic) bionic; urgency=high

  * Add multi view monitor plugin
    Support quadrant camera streams in the video recorder
  * Add license notice

 -- Nick Lamprianidis <nlamprian@gmail.com>  Fri, 14 Aug 2020 22:00:00 -0000

ros-melodic-gazebo-video-monitor-plugins (0.3.0-2bionic) bionic; urgency=high

  * Various fixes
    * Fix bug with reading the cameraReference configurations
    * Fix success field on result when discarding in stop recording
    * Add a walking actor in video monitor plugin world as a dynamic element
    * Expose recorder library
  * Add multi video monitor plugin
  * Add multi camera monitor plugin
    * Add camera contains plugin and box marker visualizer
    * Add test world for multi camera monitor and camera contains plugins
    * Use default video name in the recorder when one is not provided
    * Fix gazebo topic names for camera images in multicamera sensor

 -- Nick Lamprianidis <nlamprian@gmail.com>  Wed, 12 Aug 2020 22:00:00 -0000

ros-melodic-gazebo-video-monitor-plugins (0.2.0-2bionic) bionic; urgency=high

  * Parameterize log prefixes
  * Drop specific OpenCV version
  * Refactor gazebo video monitor plugin
    * Introduce gazebo video recorder to host recording functionality and enable reusability
    * Introduce gazebo monitor base plugin to host common members and structure plugin initialization
    * Add option to disable the window in the gazebo video monitor plugin
    * Update documentation

 -- Nick Lamprianidis <nlamprian@gmail.com>  Sun, 28 Jun 2020 22:00:00 -0000

ros-melodic-gazebo-video-monitor-plugins (0.1.1-2bionic) bionic; urgency=high

  * Set path of temporary recording
  * Add fix for initial camera attachment

 -- Nick Lamprianidis <nlamprian@gmail.com>  Wed, 22 Apr 2020 22:00:00 -0000

ros-melodic-gazebo-video-monitor-plugins (0.1.0-2bionic) bionic; urgency=high

  * Add multicamera sensor and video monitor plugin

 -- Nick Lamprianidis <nlamprian@gmail.com>  Mon, 20 Apr 2020 22:00:00 -0000

=== debian/control ===
Source: ros-melodic-gazebo-video-monitor-plugins
Section: misc
Priority: optional
Maintainer: Nick Lamprianidis <nlamprian@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libopencv-dev, libyaml-cpp-dev, ros-melodic-catkin, ros-melodic-gazebo-ros, ros-melodic-gazebo-video-monitor-msgs, ros-melodic-roscpp, ros-melodic-std-srvs
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-gazebo-video-monitor-plugins
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libopencv-dev, ros-melodic-gazebo-ros, ros-melodic-gazebo-video-monitor-msgs, ros-melodic-roscpp, ros-melodic-std-srvs
Description: gazebo_video_monitor_plugins is a package that lets the user record videos of a Gazebo simulation.
 It provides a multicamera sensor that can be used for creating different types of videos with multiple views from inside the gazebo world. There is a number of plugins already available in the package, but more can be developed by the user, with minimal effort, to fit arbitrary use cases.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-gazebo-video-monitor-plugins//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
